
/*
 *  LISTEN.C
 *
 *  LISTEN port
 *
 *  receives data from port and prints results.
 */

#include <exec/types.h>
#include <exec/io.h>
#include <exec/ports.h>
#include <libraries/dos.h>
#include <devices/parnet.h>

typedef struct IORequest IOR;
typedef struct MsgPort	 PORT;

IOParReq Iob[2];

extern PORT *CreatePort();

int
brk()
{
    return(0);
}

void
main(ac, av)
char *av[];
{
    PORT *port = CreatePort(NULL, 0);
    char buf1[16];
    char buf2[16];

    onbreak(brk);
    Iob[0].io_Message.mn_ReplyPort = port;
    Iob[0].io_Port = atoi(av[1]);
    Iob[0].io_Flags= PRO_DGRAM;

    if (OpenDevice("parnet.device", 0, (IOR *)&Iob[0], 0)) {
	printf("Unable to open parnet.device, error %d %d\n", Iob[0].io_Error, Iob[0].io_Actual);
	exit(1);
    }
    printf("Device $%08lx Unit $%08lx\n", Iob[0].io_Device, Iob[0].io_Unit);

    Iob[0].io_Command = CMD_READ;
    Iob[0].io_Data    = (APTR)buf1;
    Iob[0].io_Length  = sizeof(buf1);

    Iob[1] = Iob[0];
    Iob[1].io_Data    = (APTR)buf2;

    SendIO((IOR *)&Iob[0]);
    SendIO((IOR *)&Iob[1]);

    for (;;) {
	long mask;
	IOParReq *io;

	mask = Wait(SIGBREAKF_CTRL_E | (1 << port->mp_SigBit));

	if (mask & SIGBREAKF_CTRL_E)
	    break;

	while (io = (IOParReq *)GetMsg(port)) {
	    if (io->io_Actual < 0)
		printf("READ %d\n", io->io_Actual);
	    else {
		((char *)io->io_Data)[io->io_Actual] = 0;
		printf("READ %d %s\n", io->io_Actual, io->io_Data);
	    }
	    SendIO((IOR *)io);
	}
    }
    printf("Aborting...\n");
    AbortIO((IOR *)&Iob[0]);
    AbortIO((IOR *)&Iob[1]);
    WaitIO((IOR *)&Iob[0]);
    WaitIO((IOR *)&Iob[1]);
    printf("Closing...\n");
    CloseDevice((IOR *)&Iob[0]);
    DeletePort(port);
}

